#cython: language_level=3

from .capi.obidms       cimport OBIDMS_p
from .capi.obidmscolumn cimport OBIDMS_column_p
from .capi.obitypes     cimport obiversion_t, OBIType_t

cdef class OBIDMS_column
            
cdef class OBIDMS:

    cdef OBIDMS_p pointer
    cdef str dms_name
    
    cpdef dict list(self)
    
    cpdef OBIDMS_column open_column(self,
                                    str column_name,
                                    bint create=*, 
                                    bint clone=*, bint clone_data=*,
                                    obiversion_t version_number=*, 
                                    OBIType_t data_type=*,
                                    size_t nb_lines=*, 
                                    size_t nb_elements_per_line=*, 
                                    str elements_names=*)


cdef class OBIDMS_column:

    cdef OBIDMS_column_p pointer
    cdef OBIDMS dms
    cdef str data_type   # TODO keep as OBIType_t? both?
    cdef str dms_name
    cdef str column_name

    cpdef object get_item(self, size_t line_nb, str element_name)
    cpdef list   get_elements_names(self)
    cpdef str    get_data_type(self)
    cpdef size_t get_nb_lines_used(self)
