#cython: language_level=3

from ..capi.obidms   cimport OBIDMS_p
from ..capi.obitypes cimport const_char_p, \
                             OBIType_t, \
                             obiversion_t, \
                             obiint_t, \
                             obibool_t, \
                             obichar_t, \
                             obifloat_t, \
                             obiidx_t

cdef extern from "obidmscolumn.h" nogil:
    struct OBIDMS_column_t:
        pass

    ctypedef OBIDMS_column_t* OBIDMS_column_p

    OBIDMS_column_p obi_create_column(OBIDMS_p dms, 
                                      const_char_p column_name, 
                                      OBIType_t type, 
                                      size_t nb_lines, 
                                      size_t nb_elements_per_line, 
                                      const_char_p elements_names)
    
    size_t obi_column_get_nb_lines_used(OBIDMS_column_p column)
    
    const_char_p obi_column_get_elements_names(OBIDMS_column_p column)
    
    void obi_column_make_unwritable(OBIDMS_column_p column)
    
    OBIDMS_column_p obi_open_column(OBIDMS_p dms, 
                                    const_char_p column_name, 
                                    obiversion_t version_number)
    
    OBIType_t obi_column_get_type(OBIDMS_column_p column)
    
    int obi_close_column(OBIDMS_column_p column)
    
    OBIType_t obi_column_get_data_type_from_name(OBIDMS_p dms, 
                                                 const_char_p column_name)
    
    OBIDMS_column_p obi_clone_column(OBIDMS_p dms, 
                                     const_char_p column_name, 
                                     obiversion_t version_number, 
                                     bint clone_data)
    
    int obi_truncate_and_close_column(OBIDMS_column_p column)
    
    obiversion_t obi_column_get_latest_version_from_name(OBIDMS_p dms, 
                                                         const_char_p column_name)
    
    OBIType_t obi_column_get_data_type_from_name(OBIDMS_p dms, 
                                                 const_char_p column_name)
    
    size_t obi_column_get_line_count_from_name(OBIDMS_p dms, 
                                               const_char_p column_name)
    
    
cdef extern from "obidmscolumn_int.h" nogil:
    int obi_column_set_obiint_with_elt_name(OBIDMS_column_p column, 
                                            size_t line_nb, 
                                            const_char_p element_name, 
                                            obiint_t value)
    
    obiint_t obi_column_get_obiint_with_elt_name(OBIDMS_column_p column, 
                                                 size_t line_nb, 
                                                 const_char_p element_name)

cdef extern from "obidmscolumn_bool.h" nogil:

    int obi_column_set_obibool_with_elt_name(OBIDMS_column_p column, 
                                             size_t line_nb, 
                                             const_char_p element_name, 
                                             obibool_t value)
    
    obibool_t obi_column_get_obibool_with_elt_name(OBIDMS_column_p column, 
                                                   size_t line_nb, 
                                                   const_char_p element_name)

cdef extern from "obidmscolumn_char.h" nogil:

    int obi_column_set_obichar_with_elt_name(OBIDMS_column_p column, 
                                             size_t line_nb, 
                                             const_char_p element_name, 
                                             obichar_t value)
    
    obichar_t obi_column_get_obichar_with_elt_name(OBIDMS_column_p column, 
                                                   size_t line_nb, 
                                                   const_char_p element_name)

cdef extern from "obidmscolumn_float.h" nogil:

    int obi_column_set_obifloat_with_elt_name(OBIDMS_column_p column, 
                                              size_t line_nb, 
                                              const_char_p element_name, 
                                              obifloat_t value)
    
    obifloat_t obi_column_get_obifloat_with_elt_name(OBIDMS_column_p column, 
                                                     size_t line_nb, 
                                                     const_char_p element_name)

cdef extern from "obidmscolumn_idx.h" nogil:

    int obi_column_set_obiidx_with_elt_name(OBIDMS_column_p column, 
                                            size_t line_nb, 
                                            const_char_p element_name, 
                                            obiidx_t value)
    
    obiidx_t obi_column_get_obiidx_with_elt_name(OBIDMS_column_p column, 
                                                 size_t line_nb, 
                                                 const_char_p element_name)

